
#include<stdio.h>

typedef char DATA;

struct linked_list { 
  DATA d;
  struct linked_list *next;
};

typedef struct linked_list ELEMENT;
typedef ELEMENT* LINK; 

int conta_elementi(LINK h) {
  int lunghezza = 0;
 
  while (h != NULL) {
    lunghezza++;
    h=h->next;
  }
  return lunghezza;
}

int conta_elementi_ric(LINK h) {
  if (h==NULL) return 0;
  return (1 + conta_elementi_ric(h->next));
}

int main() {
  /*
    printf("la dimensione della struttura in byte e' %d\n", sizeof(struct linked_list)); 
  */

  LINK head;
  head = NULL;

  char c = 'A';

  head = malloc(sizeof(ELEMENT));
  head->d = 'A';
  head->next = NULL;

  head->next = malloc(sizeof(ELEMENT));
  head->next->d = 'B';
  head->next->next = NULL;

  printf("Il numero di elementi e' %d\n", conta_elementi_ric(head));
  printf("Il primo elemento e' %c\n", head->d);
}
